############################################################################ 
# 
#                            Invstack 
# 
#       Ilustrates CG inversion of Nearest neighbor modeling
############################################################################ 
#
#	Nmoinv [v=1000 o2=0. d2=200. n2=20 niter=n1] <model.H>out.H
#
#	v = velocity (if constant)
#	niter = number of steps of the CG inversion
#	out = input model + modeling +result of transpose of mod 
#		+ subsequent steps of CG
#
#	written by carlos and jon 6-11-91
#%

integer n1,n2,niter,n2out
real d1,d2,o1,o2,v

from history	:	integer n1:n1
from history	:	real    d1:d1 , o1:o1=0.0

from par	:	integer    n2:n2=20 , niter:niter=n1
from par	:	real    v:v=1000. , d2:d2=200. , o2:o2=0.

n2out=niter+4+n2
to history      :       integer n1:n1 , n2:n2out
to history      :       real d1:d1 , d2:d2

allocate	:	real gather(n1,n2),model(n1),out(n1)
allocate	:	real res(n1,n2)

subroutine instack(n1,n2,niter,d1,d2,o1,o2,v,gather,model,out,res)
integer n1,n2, iter,niter, i,j
real d1,d2,o1,o2,v
real model(n1), out(n1), gather(n1,n2),slow, res(n1,n2)

slow=1./v

call hclose()

call sreed('in', model, n1*4)

do j= 1, n1				# dummy trace
	out(j) = 0.0

call imospray(0,0,slow,o2,d2,o1,d1,n2,n1,model,gather)		# modeling

call srite('out',model,n1*4)
call srite('out',out,n1*4)
call srite('out',gather,n1*n2*4)
call srite('out',out,n1*4)

do iter=0,niter {			# CG solver
	call invstack(n1,out,n2,gather,res,o1,o2,d1,d2,slow,iter)  
	call srite('out',out,n1*4)
	}

call exit(0); end

