program Squeeze
  !
  !  <vesuvio.H Squeeze.x box=2 > squeeze.H
  !
  use sep

  implicit none
  integer 	                        :: n1, n2, n3, m1, m2, i1, i2, box
  real                                  :: d1, o1, d2, o2
  complex, dimension (:,:), allocatable	:: data, sque

  call sep_init ()
  call from_history (n1,n2, esize = 8)
  call from_history ("n3",n3,1)

  call from_par ("box",box,2)
  m1 = n1 / box
  m2 = n2 / box

  call to_history ("n1",m1)
  call to_history ("n2",m2)

  call from_history ("d1",d1,1.) ; call to_history ("d1",d1*box)
  call from_history ("d2",d2,1.) ; call to_history ("d2",d2*box)

  call from_history ("o1",o1,0.) ; call to_history ("o1",o1 + d1*box/2)
  call from_history ("o2",o2,0.) ; call to_history ("o2",o2 + d2*box/2)

  call sep_close ()

  allocate (data (n1,n2))
  allocate (sque (m1,m2))

  call sep_read (data)

  do i2 = 1, m2
     do i1 = 1, m1
        sque (i1, i2) = sum (data ((i1-1)*box+1:i1*box,(i2-1)*box+1:i2*box))
     end do
  end do

  call sep_write (sque)

  call exit (0)
end program Squeeze





