program cx2real
  !
  !  <vesuvio.H cx2real.x part=0 > amp.H
  !  <vesuvio.H cx2real.x part=1 > phz.H
  !  <vesuvio.H cx2real.x part=2 > ril.H
  !  <vesuvio.H cx2real.x part=3 > img.H
  !
  use sep

  implicit none
  integer 	                        :: n1, n2, n3, part
  complex, dimension (:,:), allocatable	:: data
  real,    dimension (:,:), allocatable :: comp

  call sep_init ()
  call from_history (n1,n2, esize = 8)
  call from_history ("n3",n3,1)

  allocate (data (n1,n2))
  allocate (comp (n1,n2))

  call from_par ("part",part,0)
  call to_history ("esize",4)
  call sep_close ()

  call sep_read (data)

  select case (part)
  case (0) 
     comp = sqrt (sqrt (cabs (data)))
  case (1) 
     comp = atan2 (aimag (data), real (data))
  case (2)
     comp = real (data)
  case (3)
     comp = aimag (data)
  case default
     call erexit ('part /= 0123')
  end select

  call sep_write (comp)

  call exit (0)
end program cx2real
