program mount
  !
  !  mount.x > mount.H
  !
  use sep

  implicit none

  integer   :: n1, n2, i, j, ih
  real      :: o1, o2, d1, d2, radius, lag, alt, xr, yr, zr, x

  real,    dimension (:,:), allocatable :: hh

  call sep_init ()
  call from_par ("n1",n1,50)
  call from_par ("n2",n2,50)

  call to_history ("n3",1)
  call to_history ("esize",4)

  call from_par ("d1",d1,1.) ; call from_par ("o1",o1,-d1*n1/2.)
  call from_par ("d2",d2,1.) ; call from_par ("o2",o2,-d2*n2/2.)

  call from_par ("radius",radius,10.)
  call from_par ("lag",lag,0.3)
  call from_par ("alt",alt,10.)

  call sep_close ()

  allocate (hh(n1,n2)) ; hh = 0.

  do j = 1, n2 ;        yr =     o2 + d2*(j-1)
     do i= 1,n1*6 ;	xr = -d1*n1 + d1*(i-1)/3.
        zr = alt * exp( - ( xr**2 + yr**2) / radius**2 ) 
        x = xr + (zr-alt/2.)*lag*n1*d1/radius
        ih = 1.5 + (x-o1)/d1
        if (ih>0 .and. ih <=n1 .and. hh (ih,j) < zr) hh (ih,j) = zr
     end do
  end do

  call sep_write (hh)

  deallocate (hh)
  call exit (0)
end program mount

