program Carlos
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
  ! 
  !                            Invstack 
  ! 
  !       Ilustrates CG inversion of Nearest neighbor modeling
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
  !
  !	v = velocity (if constant)
  !	niter = number of steps of the CG inversion
  !	out = input model + modeling +result of transpose of mod 
  !		+ subsequent steps of CG
  !
  !	written by carlos and jon 6-11-91
  use sep
  use solver_tiny_mod
  use cgstep_mod
  use imospray

  implicit none

  integer 				:: n1,n2,niter,n2out,stat,iter
  real 					:: d1,d2,o1,o2,v,slow
  real, dimension   (:), allocatable	:: model, out, dat

  call sep_init()

  call from_history (n1)
  call from_history ("d1",d1)
  call from_history ("o1",o1,0.)
  call from_par ("n2",n2,20)
  call from_par ("niter",niter,n1)
  call from_par ("v",v,1000.)
  call from_par ("d2",d2,200.)
  call from_par ("o2",o2,0.)

  n2out=niter+4+n2
  call to_history ("n2",n2out)
  call sep_close ()

  allocate (dat (n1*n2), model (n1), out (n1))

  slow=1./v

  call sep_read (model)

  out = 0.0						! dummy trace

  call imospray_init (slow, o2,d2, o1,d1, n1,n2)
  stat = imospray_lop (.false.,.false.,model,dat) 	! modeling

  call sep_write (model)
  call sep_write (out)
  call sep_write (dat)
  call sep_write (out)

  do iter=1,niter + 1 					! CG solver
     call solver_tiny( m=out, d=dat, Fop=imospray_lop, stepper=cgstep, niter=iter)
     call cgstep_close ()
     call sep_write (out)
  end do

  deallocate (model, dat, out)
  call exit(0)
end program Carlos








