program Ungrad
  !
  !  <vesuvio.H Ungrad.x > height.H
  !
  use sep
  use unwrap

  implicit none
  integer 	                          :: n1, n2, n3, niter, iter
  real                                    :: q
  complex, dimension (:,:),   allocatable :: data
  real,    dimension (:,:),   allocatable :: bad
  real,    dimension (:),     allocatable :: hh
  real,    dimension (:,:,:), allocatable :: rt, rmov

  call sep_init ()
  call from_history (n1,n2, esize = 8)
  call from_history ("n3",n3,1)

  call to_history ("esize",4)
  call from_par ("niter", niter, 0)
  call from_par ("q", q, 1.)

  if (exist_file ("badness")) then
     call to_history ("n1",   n1, "badness")
     call to_history ("n2",   n2, "badness")
     call to_history ("n3",    1, "badness")
     call to_history ("esize", 4, "badness")
  end if
  call sep_close ()

  allocate (data (n1,n2))                                   ! read data
  call sep_read (data) ; data = data / maxval (cabs (data)) ! normalize

  if (exist_file ("badness")) then
     allocate (bad (n1,n2), rt (n1,n2,2)) ; call grad2init (data, n1, n2, rt)
     bad = 0.
     bad (1:n1-2,1:n2-2) =                         &
     (rt(1:n1-2,2:n2-1,1) - rt(1:n1-2,1:n2-2,1)) - &
     (rt(2:n1-1,1:n2-2,2) - rt(1:n1-2,1:n2-2,2)) 

     call sep_write (bad, "badness") ; deallocate (bad, rt)
  end if

  if (niter > 0) then
     allocate (hh (n1*n2))
     call unwraper (data, hh, niter)            
     call sep_write (hh) 
     deallocate (hh)
  end if

  deallocate (data)
  call exit (0)
end program Ungrad





